/*!
 * @file aiming_turret.h
*/


#ifndef _AIMING_TURRET_H
#define _AIMING_TURRET_H

#include "weapon.h"
#include "aim.h"
/* FORWARD DECLARATION */

class AimingTurret : public Weapon
{
  ObjectListDeclaration(AimingTurret);

public:
  AimingTurret ();
  AimingTurret(const TiXmlElement* root);
  virtual ~AimingTurret ();

  virtual void loadParams(const TiXmlElement* root);

  void setTargetGroup(OM_LIST targetGroup) { this->target.setTargetGroup(targetGroup); };

  virtual void activate();
  virtual void deactivate();

  virtual void tick(float dt);
  virtual void fire();


  virtual void draw() const;

private:
  void init();

private:
  Aim           target;
};

#endif /* _AIMING_TURRET_H */
